searchNodes=[{"type":"module","title":"Slime","doc":"Slim-like HTML templates.","ref":"Slime.html"},{"type":"macro","title":"Slime.function_from_file/5","doc":"Generates a function definition from the file contents. The kind ( :def or :defp ) must be given, the function name, its arguments and the compilation options. This function is useful in case you have templates but you want to precompile inside a module for speed. Examples # sample.slim = a + b # sample.ex defmodule Sample do require Slime Slime . function_from_file :def , :sample , &quot;sample.slime&quot; , [ :a , :b ] end # iex Sample . sample ( 1 , 2 ) #=&gt; &quot;3&quot;","ref":"Slime.html#function_from_file/5"},{"type":"macro","title":"Slime.function_from_string/5","doc":"Generates a function definition from the string. The kind ( :def or :defp ) must be given, the function name, its arguments and the compilation options. Examples iex&gt; defmodule Sample do ...&gt; require Slime ...&gt; Slime . function_from_string :def , :sample , &quot;= a + b&quot; , [ :a , :b ] ...&gt; end iex&gt; Sample . sample ( 1 , 2 ) &quot;3&quot;","ref":"Slime.html#function_from_string/5"},{"type":"function","title":"Slime.render/1","doc":"See Slime.Renderer.render/1 .","ref":"Slime.html#render/1"},{"type":"function","title":"Slime.render/2","doc":"See Slime.Renderer.render/2 .","ref":"Slime.html#render/2"},{"type":"module","title":"Slime.Compiler","doc":"Compile a tree of parsed Slime into EEx.","ref":"Slime.Compiler.html"},{"type":"function","title":"Slime.Compiler.compile/1","doc":"","ref":"Slime.Compiler.html#compile/1"},{"type":"function","title":"Slime.Compiler.hide_dialyzer_spec/1","doc":"","ref":"Slime.Compiler.html#hide_dialyzer_spec/1"},{"type":"module","title":"Slime.Doctype","doc":"Mapping doctype shorthands to their actual values.","ref":"Slime.Doctype.html"},{"type":"function","title":"Slime.Doctype.for/1","doc":"","ref":"Slime.Doctype.html#for/1"},{"type":"module","title":"Slime.Parser","doc":"Build a Slime tree from a Slime document.","ref":"Slime.Parser.html"},{"type":"function","title":"Slime.Parser.parse/1","doc":"","ref":"Slime.Parser.html#parse/1"},{"type":"module","title":"Slime.Parser.AttributesKeyword","doc":"Utilities for handling element attributes.","ref":"Slime.Parser.AttributesKeyword.html"},{"type":"function","title":"Slime.Parser.AttributesKeyword.merge/2","doc":"Merges multiply attributes values for keys specified in merge_rules. Attribute value may be given by string, list, or {:eex, args} node merge_rules should me an %{attribute_name: joining_character} map Examples iex&gt; Slime.Parser.AttributesKeyword . merge ( ...&gt; [ class : &quot;a&quot; , class : [ &quot;b&quot; , &quot;c&quot; ] , class : &quot;d&quot; ] , ...&gt; %{ class : &quot; &quot; } ...&gt; ) [ class : &quot;a b c d&quot; ] iex&gt; Slime.Parser.AttributesKeyword . merge ( ...&gt; [ class : &quot;a&quot; , class : [ &quot;b&quot; , &quot;c&quot; ] , class : { :eex , &quot;d&quot; } ] , ...&gt; %{ class : &quot; &quot; } ...&gt; ) [ class : { :eex , ~S(&quot;a b c \#{d}&quot;) } ]","ref":"Slime.Parser.AttributesKeyword.html#merge/2"},{"type":"behaviour","title":"Slime.Parser.EmbeddedEngine","doc":"Embedded engine behaviour module. Provides basic logic of parsing slime with embedded parts for other engines.","ref":"Slime.Parser.EmbeddedEngine.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.parse/2","doc":"","ref":"Slime.Parser.EmbeddedEngine.html#parse/2"},{"type":"callback","title":"Slime.Parser.EmbeddedEngine.render/2","doc":"","ref":"Slime.Parser.EmbeddedEngine.html#c:render/2"},{"type":"type","title":"Slime.Parser.EmbeddedEngine.engine_input/0","doc":"","ref":"Slime.Parser.EmbeddedEngine.html#t:engine_input/0"},{"type":"type","title":"Slime.Parser.EmbeddedEngine.parser_tag/0","doc":"","ref":"Slime.Parser.EmbeddedEngine.html#t:parser_tag/0"},{"type":"module","title":"Slime.Parser.EmbeddedEngine.Css","doc":"CSS engine callback module","ref":"Slime.Parser.EmbeddedEngine.Css.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.Css.render/2","doc":"Callback implementation for Slime.Parser.EmbeddedEngine.render/2 .","ref":"Slime.Parser.EmbeddedEngine.Css.html#render/2"},{"type":"module","title":"Slime.Parser.EmbeddedEngine.EEx","doc":"EEx engine callback module","ref":"Slime.Parser.EmbeddedEngine.EEx.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.EEx.render/2","doc":"Callback implementation for Slime.Parser.EmbeddedEngine.render/2 .","ref":"Slime.Parser.EmbeddedEngine.EEx.html#render/2"},{"type":"module","title":"Slime.Parser.EmbeddedEngine.Elixir","doc":"Elixir code engine callback module","ref":"Slime.Parser.EmbeddedEngine.Elixir.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.Elixir.render/2","doc":"Callback implementation for Slime.Parser.EmbeddedEngine.render/2 .","ref":"Slime.Parser.EmbeddedEngine.Elixir.html#render/2"},{"type":"module","title":"Slime.Parser.EmbeddedEngine.Javascript","doc":"Javascript engine callback module","ref":"Slime.Parser.EmbeddedEngine.Javascript.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.Javascript.render/2","doc":"Callback implementation for Slime.Parser.EmbeddedEngine.render/2 .","ref":"Slime.Parser.EmbeddedEngine.Javascript.html#render/2"},{"type":"module","title":"Slime.Parser.Nodes","doc":"","ref":"Slime.Parser.Nodes.html"},{"type":"module","title":"Slime.Parser.Nodes.DoctypeNode","doc":"A doctype node. :name is a Slim shorthand (e.g. &quot;xml&quot; or &quot;html&quot;).","ref":"Slime.Parser.Nodes.DoctypeNode.html"},{"type":"module","title":"Slime.Parser.Nodes.EExNode","doc":"An embedded code node. :content — embedded code, :output — should the return value be inserted in the page, :spaces — tag whitespace, represented as a keyword list of boolean values for :leading and :trailing, :children — a list of nodes. :safe? - mark output as safe for html-escaping engines","ref":"Slime.Parser.Nodes.EExNode.html"},{"type":"module","title":"Slime.Parser.Nodes.HTMLCommentNode","doc":"An HTML comment node. Similar to Slime.Parser.Nodes.VerbatimTextNode .","ref":"Slime.Parser.Nodes.HTMLCommentNode.html"},{"type":"module","title":"Slime.Parser.Nodes.HTMLNode","doc":"An HTML node. :name — tag name, :attributes — a list of {&quot;name&quot;, :v} tuples, where :v is either a string or an {:eex, &quot;content&quot;} tuple, :spaces — tag whitespace, represented as a keyword list of boolean values for :leading and :trailing, :closed — the presence of a trailing &quot;/&quot;, which explicitly closes the tag, :children — a list of nodes.","ref":"Slime.Parser.Nodes.HTMLNode.html"},{"type":"module","title":"Slime.Parser.Nodes.InlineHTMLNode","doc":"An inline HTML node. Similar to Slime.Parser.Nodes.VerbatimTextNode , with the exeption of :children field, which represents a list of nodes indented deeper than the HTML content.","ref":"Slime.Parser.Nodes.InlineHTMLNode.html"},{"type":"module","title":"Slime.Parser.Nodes.VerbatimTextNode","doc":"A verbatim text node. :content — a list of strings and %EExNode{} structs that is concatenated during rendering. No newlines or spaces are inserted between individual items.","ref":"Slime.Parser.Nodes.VerbatimTextNode.html"},{"type":"module","title":"Slime.Parser.Preprocessor","doc":"This module helps to process input and insert indents and dedents to simplify parser design.","ref":"Slime.Parser.Preprocessor.html"},{"type":"function","title":"Slime.Parser.Preprocessor.dedent_meta_symbol/0","doc":"","ref":"Slime.Parser.Preprocessor.html#dedent_meta_symbol/0"},{"type":"function","title":"Slime.Parser.Preprocessor.indent/1","doc":<<84, 97, 107, 101, 115, 32, 97, 110, 32, 105, 110, 112, 117, 116, 32, 98, 105, 110, 97, 114, 121, 32, 97, 110, 100, 32, 105, 110, 115, 101, 114, 116, 115, 32, 118, 105, 114, 116, 117, 97, 108, 32, 105, 110, 100, 101, 110, 116, 32, 97, ...>>,"ref":"Slime.Parser.Preprocessor.html#indent/1"},{"type":"function","title":"Slime.Parser.Preprocessor.indent_meta_symbol/0","doc":"","ref":"Slime.Parser.Preprocessor.html#indent_meta_symbol/0"},{"type":"function","title":"Slime.Parser.Preprocessor.indent_size/1","doc":"Counts indent size by indent string using :tab_size config option Examples: iex&gt; Slime.Parser.Preprocessor . indent_size ( &quot; &quot; ) 4 iex&gt; Slime.Parser.Preprocessor . indent_size ( &quot; &quot; ) 4 iex&gt; Slime.Parser.Preprocessor . indent_size ( &quot;&quot; ) 0","ref":"Slime.Parser.Preprocessor.html#indent_size/1"},{"type":"function","title":"Slime.Parser.Preprocessor.process/1","doc":"","ref":"Slime.Parser.Preprocessor.html#process/1"},{"type":"function","title":"Slime.Parser.Preprocessor.remove_trailing_spaces/1","doc":"Removes trailing whitespace, leaving newlines intact.","ref":"Slime.Parser.Preprocessor.html#remove_trailing_spaces/1"},{"type":"module","title":"Slime.Parser.TextBlock","doc":"Utilities for parsing text blocks.","ref":"Slime.Parser.TextBlock.html"},{"type":"function","title":"Slime.Parser.TextBlock.render_content/2","doc":"Given a text block and its declaration indentation level (see below), produces a string (or a dynamic EEx tuple) that can be inserted into the tree. nested | Text block that spans over multiple lines ^ declaration indent","ref":"Slime.Parser.TextBlock.html#render_content/2"},{"type":"function","title":"Slime.Parser.TextBlock.render_without_indentation/1","doc":"Given a text block, returns the text without indentation.","ref":"Slime.Parser.TextBlock.html#render_without_indentation/1"},{"type":"module","title":"Slime.Parser.Transform","doc":"PEG parser callbacks module. Define transformations from parsed iolist to ast. See https://github.com/seancribbs/neotoma/wiki#working-with-the-ast","ref":"Slime.Parser.Transform.html"},{"type":"function","title":"Slime.Parser.Transform.expand_shortcut/2","doc":"","ref":"Slime.Parser.Transform.html#expand_shortcut/2"},{"type":"function","title":"Slime.Parser.Transform.expand_tag_shortcut/1","doc":"","ref":"Slime.Parser.Transform.html#expand_tag_shortcut/1"},{"type":"function","title":"Slime.Parser.Transform.newlines/1","doc":"","ref":"Slime.Parser.Transform.html#newlines/1"},{"type":"function","title":"Slime.Parser.Transform.transform/3","doc":"","ref":"Slime.Parser.Transform.html#transform/3"},{"type":"type","title":"Slime.Parser.Transform.ast/0","doc":"","ref":"Slime.Parser.Transform.html#t:ast/0"},{"type":"type","title":"Slime.Parser.Transform.index/0","doc":"","ref":"Slime.Parser.Transform.html#t:index/0"},{"type":"module","title":"Slime.Renderer","doc":"Transform Slime templates into HTML.","ref":"Slime.Renderer.html"},{"type":"function","title":"Slime.Renderer.precompile/1","doc":"Compile Slime template to valid EEx HTML. Examples iex&gt; Slime.Renderer . precompile ( ~s(input.required type=&quot;hidden&quot;) ) &quot;&lt;input class= \\&quot; required \\&quot; type= \\&quot; hidden \\&quot; &gt;&quot;","ref":"Slime.Renderer.html#precompile/1"},{"type":"function","title":"Slime.Renderer.render/3","doc":"Takes a Slime template as a string as well as a set of bindings, and renders the resulting HTML. Note that this method of rendering is substantially slower than rendering precompiled templates created with Slime.function_from_file/5 and Slime.function_from_string/5.","ref":"Slime.Renderer.html#render/3"},{"type":"exception","title":"Slime.TemplateSyntaxError","doc":"Syntax exception which may appear during parsing and compilation processes","ref":"Slime.TemplateSyntaxError.html"}]